## net.i2p.client.streaming
Class I2PSocketManagerImpl

    java.lang.Object
      net.i2p.client.streaming.I2PSocketManagerImpl

All Implemented Interfaces:
  I2PSessionListener, I2PSocketManager

class I2PSocketManagerImpl
extends java.lang.Object
implements I2PSocketManager, I2PSessionListener

Centralize the coordination and multiplexing of the local client's streaming. There should be one I2PSocketManager for each I2PSession, and if an application is sending and receiving data through the streaming library using an I2PSocketManager, it should not attempt to call I2PSession's setSessionListener or receive any messages with its .receiveMessage

Nested Class Summary

Nested classes inherited from class net.i2p.client.streaming.I2PSocketManager
`I2PSocketManager.DisconnectListener`

Field Summary
`static short` `ACK`
`static short` `CHAFF`
`static short` `CLOSE_IN`
`static short` `CLOSE_OUT`
`static short` `DATA_IN`
`static short` `DATA_OUT`
`static short` `SYN`

Constructor Summary
`I2PSocketManagerImpl()`
`I2PSocketManagerImpl(java.lang.String name)`

Method Summary
`void` `addDisconnectListener(I2PSocketManager.DisconnectListener lsnr)`
`I2PSocketOptions` `buildOptions()`
`I2PSocketOptions` `buildOptions(java.util.Properties opts)`
`I2PSocket` `connect(Destination peer)` Create a new connected socket (block until the socket is created)
`I2PSocket` `connect(Destination peer, I2PSocketOptions options)` Create a new connected socket (block until the socket is created)
`void` `destroySocketManager()` Destroy the socket manager, freeing all the associated resources.
`void` `disconnected(I2PSession session)` Notify the client that the session has been terminated
`void` `errorOccurred(I2PSession session, java.lang.String message, java.lang.Throwable error)` Notify the client that some error occurred
`long` `getAcceptTimeout()`
`I2PSocketOptions` `getDefaultOptions()`
`java.lang.String` `getName()`
`static java.lang.String` `getReadableForm(java.lang.String id)`
`I2PServerSocket` `getServerSocket()`
`I2PSession` `getSession()`
`void` `init(I2PAppContext context, I2PSession session, java.util.Properties opts, java.lang.String name)`
`java.util.Set` `listSockets()` Retrieve a set of currently connected I2PSockets, either initiated locally or remotely.
`static byte[]` `makePacket(byte type, java.lang.String id, byte[] payload)` Create a new packet of the given type for the specified connection containing the given payload
`void` `messageAvailable(I2PSession session, int msgId, long size)` Instruct the client that the given session has received a message with size # of bytes.
`boolean` `ping(Destination peer, long timeoutMs)` Ping the specified peer, returning true if they replied to the ping within the timeout specified, false otherwise.
`void` `removeDisconnectListener(I2PSocketManager.DisconnectListener lsnr)`
`void` `removeSocket(I2PSocketImpl sock)`
`void` `reportAbuse(I2PSession session, int severity)` Instruct the client that the session specified seems to be under attack and that the client may wish to move its destination to another router.
`void` `setAcceptTimeout(long ms)` How long should we wait for the client to .accept() a socket before sending back a NACK/Close?
`void` `setDefaultOptions(I2PSocketOptions options)`
`void` `setName(java.lang.String name)`
`void` `setSession(I2PSession session)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ACK

    public static final short ACK

See Also:
  Constant Field Values

### CLOSE_OUT

    public static final short CLOSE_OUT

See Also:
  Constant Field Values

### DATA_OUT

    public static final short DATA_OUT

See Also:
  Constant Field Values

### SYN

    public static final short SYN

See Also:
  Constant Field Values

### CLOSE_IN

    public static final short CLOSE_IN

See Also:
  Constant Field Values

### DATA_IN

    public static final short DATA_IN

See Also:
  Constant Field Values

### CHAFF

    public static final short CHAFF

See Also:
  Constant Field Values

Constructor Detail

### I2PSocketManagerImpl

    public I2PSocketManagerImpl()

### I2PSocketManagerImpl

    public I2PSocketManagerImpl(java.lang.String name)

Method Detail

### init

    public void init(I2PAppContext context,
                     I2PSession session,
                     java.util.Properties opts,
                     java.lang.String name)

  Specified by:
    `init` in interface `I2PSocketManager`

### getSession

    public I2PSession getSession()

  Specified by:
    `getSession` in interface `I2PSocketManager`

### setSession

    public void setSession(I2PSession session)

### setAcceptTimeout

    public void setAcceptTimeout(long ms)

  How long should we wait for the client to .accept() a socket before sending back a NACK/Close?

  Specified by:
    `setAcceptTimeout` in interface `I2PSocketManager`
  Parameters:
    `ms` - milliseconds to wait, maximum

### getAcceptTimeout

    public long getAcceptTimeout()

  Specified by:
    `getAcceptTimeout` in interface `I2PSocketManager`

### disconnected

    public void disconnected(I2PSession session)

  Description copied from interface: `I2PSessionListener`
  Notify the client that the session has been terminated

  Specified by:
    `disconnected` in interface `I2PSessionListener`

### errorOccurred

    public void errorOccurred(I2PSession session,
                              java.lang.String message,
                              java.lang.Throwable error)

  Description copied from interface: `I2PSessionListener`
  Notify the client that some error occurred

  Specified by:
    `errorOccurred` in interface `I2PSessionListener`

### messageAvailable

    public void messageAvailable(I2PSession session,
                                 int msgId,
                                 long size)

  Description copied from interface: `I2PSessionListener`
  Instruct the client that the given session has received a message with size # of bytes.

  Specified by:
    `messageAvailable` in interface `I2PSessionListener`
  Parameters:
    `session` - session to notify
    `msgId` - message number available
    `size` - size of the message

### reportAbuse

    public void reportAbuse(I2PSession session,
                            int severity)

  Description copied from interface: `I2PSessionListener`
  Instruct the client that the session specified seems to be under attack and that the client may wish to move its destination to another router.

  Specified by:
    `reportAbuse` in interface `I2PSessionListener`
  Parameters:
    `session` - session to report abuse to
    `severity` - how bad the abuse is

### setDefaultOptions

    public void setDefaultOptions(I2PSocketOptions options)

  Specified by:
    `setDefaultOptions` in interface `I2PSocketManager`

### getDefaultOptions

    public I2PSocketOptions getDefaultOptions()

  Specified by:
    `getDefaultOptions` in interface `I2PSocketManager`

### buildOptions

    public I2PSocketOptions buildOptions()

  Specified by:
    `buildOptions` in interface `I2PSocketManager`

### buildOptions

    public I2PSocketOptions buildOptions(java.util.Properties opts)

  Specified by:
    `buildOptions` in interface `I2PSocketManager`

### getServerSocket

    public I2PServerSocket getServerSocket()

  Specified by:
    `getServerSocket` in interface `I2PSocketManager`

### connect

    public I2PSocket connect(Destination peer,
                             I2PSocketOptions options)
                      throws I2PException,
                             java.net.ConnectException,
                             java.net.NoRouteToHostException,
                             java.io.InterruptedIOException

  Create a new connected socket (block until the socket is created)

  Specified by:
    `connect` in interface `I2PSocketManager`
  Parameters:
    `peer` - Destination to connect to
    `options` - I2P socket options to be used for connecting
  Throws:
    `java.net.ConnectException` - if the peer refuses the connection
    `java.net.NoRouteToHostException` - if the peer is not found or not reachable
    `java.io.InterruptedIOException` - if the connection timeouts
    `I2PException` - if there is some other I2P-related problem

### connect

    public I2PSocket connect(Destination peer)
                      throws I2PException,
                             java.net.ConnectException,
                             java.net.NoRouteToHostException,
                             java.io.InterruptedIOException

  Create a new connected socket (block until the socket is created)

  Specified by:
    `connect` in interface `I2PSocketManager`
  Parameters:
    `peer` - Destination to connect to
  Throws:
    `java.net.ConnectException` - if the peer refuses the connection
    `java.net.NoRouteToHostException` - if the peer is not found or not reachable
    `java.io.InterruptedIOException` - if the connection timeouts
    `I2PException` - if there is some other I2P-related problem

### destroySocketManager

    public void destroySocketManager()

  Destroy the socket manager, freeing all the associated resources. This method will block untill all the managed sockets are closed.

  Specified by:
    `destroySocketManager` in interface `I2PSocketManager`

### listSockets

    public java.util.Set listSockets()

  Retrieve a set of currently connected I2PSockets, either initiated locally or remotely.

  Specified by:
    `listSockets` in interface `I2PSocketManager`

### ping

    public boolean ping(Destination peer,
                        long timeoutMs)

  Ping the specified peer, returning true if they replied to the ping within the timeout specified, false otherwise. This call blocks.

  Specified by:
    `ping` in interface `I2PSocketManager`

### removeSocket

    public void removeSocket(I2PSocketImpl sock)

### getName

    public java.lang.String getName()

  Specified by:
    `getName` in interface `I2PSocketManager`

### setName

    public void setName(java.lang.String name)

  Specified by:
    `setName` in interface `I2PSocketManager`

### addDisconnectListener

    public void addDisconnectListener(I2PSocketManager.DisconnectListener lsnr)

  Specified by:
    `addDisconnectListener` in interface `I2PSocketManager`

### removeDisconnectListener

    public void removeDisconnectListener(I2PSocketManager.DisconnectListener lsnr)

  Specified by:
    `removeDisconnectListener` in interface `I2PSocketManager`

### getReadableForm

    public static java.lang.String getReadableForm(java.lang.String id)

### makePacket

    public static byte[] makePacket(byte type,
                                    java.lang.String id,
                                    byte[] payload)

  Create a new packet of the given type for the specified connection containing the given payload